import es, playerlib, popuplib

dict_stats = {}
use_round_end = 0

def round_start(ev):
	for userid in playerlib.getPlayerList('#human'):
		user = int(userid)
		vs_user = playerlib.uniqueid(user, True)
		dict_stats[vs_user] = {}

def player_hurt(ev):
	if ev['es_userteam'] == ev['es_attackerteam']: return
	if ev['es_attackerteam'] in ('2','3'):
		userid = int(ev['userid'])
		attacker = int(ev['attacker'])
		vs_user = playerlib.uniqueid(userid, True)
		vs_attacker = playerlib.uniqueid(attacker, True)
		if ev['es_steamid'] != 'BOT':
			if not vs_attacker in dict_stats[vs_user]:
				dict_stats[vs_user][vs_attacker] = {}
				dict_stats[vs_user][vs_attacker]["wounded"] = 0
				dict_stats[vs_user][vs_attacker]["wndhits"] = 0
				dict_stats[vs_user][vs_attacker]["victim"] = 0
				dict_stats[vs_user][vs_attacker]["vichits"] = 0
				dict_stats[vs_user][vs_attacker]["oppname"] = ev['es_attackername']
				dict_stats[vs_user][vs_attacker]["killed"] = 0
			dict_stats[vs_user][vs_attacker]["victim"] += int(ev['dmg_health'])
			dict_stats[vs_user][vs_attacker]["vichits"] += 1
		if ev['es_attackersteamid'] != 'BOT':
			if not vs_user in dict_stats[vs_attacker]:
				dict_stats[vs_attacker][vs_user] = {}
				dict_stats[vs_attacker][vs_user]["wounded"] = 0
				dict_stats[vs_attacker][vs_user]["wndhits"] = 0
				dict_stats[vs_attacker][vs_user]["victim"] = 0
				dict_stats[vs_attacker][vs_user]["vichits"] = 0
				dict_stats[vs_attacker][vs_user]["oppname"] = ev['es_username']
				dict_stats[vs_attacker][vs_user]["killed"] = 0
			dict_stats[vs_attacker][vs_user]["wounded"] += int(ev['dmg_health'])
			dict_stats[vs_attacker][vs_user]["wndhits"] += 1

def player_death(ev):
	global use_round_end
	use_round_end = 1
	attacker = ev['attacker']
	user = ev['userid']
	vs_attacker = playerlib.uniqueid(attacker, True)
	vs_user = playerlib.uniqueid(user, True)
	if ev['es_attackersteamid'] != 'BOT':
		if ev['es_userteam'] != ev['es_attackerteam'] and ev['es_attackerteam'] in ('2','3'):
			dict_stats[vs_attacker][vs_user]["killed"] = 'Killed' if int(ev['headshot']) == 0 else 'HS Killed'
	if ev['es_steamid'] != 'BOT':
		stats_popup = popuplib.create(vs_user)
		list_vic(stats_popup, vs_user, user)
		list_wnd(stats_popup, vs_user, user)
		list_kil(stats_popup, vs_user, user)
		if ev['es_steamid'] == ev['es_attackersteamid']:
			killer_pop = ('    Dumbass! You just killed yourself')
		elif ev['es_steamid'] != ev['es_attackersteamid'] and ev['es_userteam'] == ev['es_attackerteam']:
			killer_pop = ('    You were team-killed by %s, with %s' % (str(es.getplayername(attacker)), str(ev['weapon'])))
		else:
			killer = 'Killer' if int(ev['headshot']) == 0 else 'HS Killer'
			killer_pop = ('    %s: %s, with %s' % (killer, str(es.getplayername(attacker)), str(ev['weapon'])))
		stats_popup.addline(' ')
		stats_popup.addline('%s' % killer_pop)
		stats_popup.timeoutview = 7
		stats_popup.send(user)

def round_end(ev):
	global use_round_end
	if use_round_end == 1:
		use_round_end = 0
		for userid in playerlib.getPlayerList('#human, #alive'):
			user = int(userid)
			vs_user = playerlib.uniqueid(user, True)
			stats_popup = popuplib.create(vs_user)
			list_vic(stats_popup, vs_user, user)
			list_wnd(stats_popup, vs_user, user)
			list_kil(stats_popup, vs_user, user)
			stats_popup.timeoutview = 7
			stats_popup.send(user)

def list_vic(stats_popup, vs_user, user):
	stats_popup.addline('->1. Attackers')
	for vs_var in dict_stats[vs_user]:
		vs_key = str(vs_var)
		damage = dict_stats[vs_user][vs_key]["victim"]
		if damage > 0:
			name = dict_stats[vs_user][vs_key]["oppname"]
			hits = dict_stats[vs_user][vs_key]["vichits"]
			typehit = 'hit' if hits == 1 else 'hits'
			vic_list = ('    %s, %s dmg in %s %s'%(name, damage, hits, typehit))
			stats_popup.addline('%s' % vic_list)
	stats_popup.addline(' ')

def list_wnd(stats_popup, vs_user, user):
	stats_popup.addline('->2. Victims')
	for vs_var in dict_stats[vs_user]:
		vs_key = str(vs_var)
		damage = dict_stats[vs_user][vs_key]["wounded"]
		if damage > 0:
			kill = dict_stats[vs_user][vs_key]["killed"]
			if kill == 0:
				name = dict_stats[vs_user][vs_key]["oppname"]
				hits = dict_stats[vs_user][vs_key]["wndhits"]
				typehit = 'hit' if hits == 1 else 'hits'
				wnd_list = ('    %s, %s dmg in %s %s - Wounded'%(name, damage, hits, typehit))
				stats_popup.addline('%s' % wnd_list)

def list_kil(stats_popup, vs_user, user):
	for vs_var in dict_stats[vs_user]:
		vs_key = str(vs_var)
		damage = dict_stats[vs_user][vs_key]["wounded"]
		if damage > 0:
			kill = dict_stats[vs_user][vs_key]["killed"]
			if kill > 0:
				name = dict_stats[vs_user][vs_key]["oppname"]
				hits = dict_stats[vs_user][vs_key]["wndhits"]
				typehit = 'hit' if hits == 1 else 'hits'
				kil_list = ('    %s, %s dmg in %s %s - %s'%(name, damage, hits, typehit, kill))
				stats_popup.addline('%s' % kil_list)